#!/usr/bin/python
##### Risanje stirizicne vijacnice - S53MV 26.2.2018 #####

import math,numpy	#uporabljene funkcije


kf=math.pi*0.001	#korak kota risanja
n=2		#stevilo ovojev
r=0.3		#polmer vijaka
xs=0.0		#zacetni x
h1=1.0		#visina daljsega para
h2=1.0		#visina krajsega para
w=1		#sirina crte
t=0.15*math.pi	#nagib slike

def vijak(r,f,kf,n,h,xs):		#risanje levega vijaka navzdol
	kh=h*kf/math.pi
	y=[]		#polja za risanje grafa
	x=[]
	z=[]
	zz=0			#zacetna precka
	ff=f
	x=x+[xs]
	y=y+[0]
	z=z+[zz]
	while ff<=f+2*n*math.pi:	#vijacnica
		x=x+[r*math.cos(ff)]
		y=y+[r*math.sin(ff)]
		z=z+[zz]
		zz=zz-kh
		ff=ff+kf
	x=x+[0]			#koncna precka
	y=y+[0]
	z=z+[zz]
	return [x,y,z]

def nagib(y,z,t):		#nagib slike
	return numpy.multiply(z,math.cos(t))+numpy.multiply(y,math.sin(t))

import matplotlib.pyplot as plt		#risanje grafa funkcije

f=0.25*math.pi
[x,y,z]=vijak(r,f,kf,n,h1,xs)
u=nagib(y,z,t)
plt.plot(x,u,'m-',lw=w)

f=1.75*math.pi
[x,y,z]=vijak(r,f,kf,n,h2,xs)
u=nagib(y,z,t)
plt.plot(x,u,'b-',lw=w)

f=1.25*math.pi
[x,y,z]=vijak(r,f,kf,n,h1,-xs)
u=nagib(y,z,t)
plt.plot(x,u,'r-',lw=w)

f=0.75*math.pi
[x,y,z]=vijak(r,f,kf,n,h2,-xs)
u=nagib(y,z,t)
plt.plot(x,u,'g-',lw=w)

plt.axis([-2*r,2*r,-h2*2*n-r,r])
plt.axes().set_aspect('equal')
plt.axis('off')
plt.show()

#konec programa

